package com.sf.service.gateway.domain;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import com.sf.common.annotation.Excel;
import com.sf.common.core.domain.BaseEntity;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Pattern;


/**
 * 接口管理对象 Gateway_interface_info
 * 
 * @author zoukun
 * @date 2024-04-22
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value = "GatewayInterfaceInfo", description = "接口信息对象")
public class GatewayInterfaceInfo extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** ID */
    @ApiModelProperty("ID")
    private Long id;

    /** 接口名称 */
    @Excel(name = "接口名称")
    @ApiModelProperty("接口名称")
    private String interfaceName;

    /** api编码 */
    @ApiModelProperty("接口编码")
    private String apiCode;

    /** 接口路径 */
    @Excel(name = "接口路径")
    @ApiModelProperty("接口名称")
    private String interfacePath;

    /** 请求方式 */
    @Excel(name = "请求方式")
    @ApiModelProperty("请求方式")
    private String requestMethod;

    /** 接口描述 */
    @Excel(name = "接口描述")
    @ApiModelProperty("接口描述")
    private String description;

    /** 接口版本 */
    @Excel(name = "接口版本")
    @ApiModelProperty("接口版本")
    private String version;

    /** 接口状态（0停用 1启用） */
    @Excel(name = "接口状态", readConverterExp = "0=停用,1=启用")
    @ApiModelProperty("接口状态(0=停用,1=启用)")
    private String status;

    /** 接口文档（文档地址） */
    @Excel(name = "接口文档", readConverterExp = "文档地址")
    @ApiModelProperty("接口文档（文档地址）")
    private String document;

    @ApiModelProperty("创建者")
    private String created;

    @ApiModelProperty("更新者")
    private String modified;

    @ApiModelProperty("应用编号")
    private String appCode;

    @ApiModelProperty("网关服务id")
    private Long serverId;

    @ApiModelProperty("Mock状态(0=停用,1=启用)")
    private String mockStatus;

    @ApiModelProperty("Mock响应，json格式")
    private String mockResponse;

}
